#ifndef __24L01_H
#define __24L01_H   
#include <stdbool.h>
#include <stdint.h>

//NRF24L01Ĵ
#define NRF_READ_REG    0x00  //üĴ,5λΪĴַ
#define NRF_WRITE_REG   0x20  //дüĴ,5λΪĴַ
#define RD_RX_PLOAD     0x61  //RXЧ,1~32ֽ
#define WR_TX_PLOAD     0xA0  //дTXЧ,1~32ֽ
#define FLUSH_TX        0xE1  //TX FIFOĴ.ģʽ
#define FLUSH_RX        0xE2  //RX FIFOĴ.ģʽ
#define REUSE_TX_PL     0xE3  //ʹһ,CEΪ,ݰϷ.
#define NOP             0xFF  //ղ,״̬Ĵ 
//SPI(NRF24L01)Ĵַ
#define CONFIG          0x00  //üĴַ;bit0:1ģʽ,0ģʽ;bit1:ѡ;bit2:CRCģʽ;bit3:CRCʹ;
                              //bit4:жMAX_RT(ﵽطж)ʹ;bit5:жTX_DSʹ;bit6:жRX_DRʹ
#define EN_AA           0x01  //ʹԶӦ  bit0~5,Ӧͨ0~5
#define EN_RXADDR       0x02  //յַ,bit0~5,Ӧͨ0~5
#define SETUP_AW        0x03  //õַ(ͨ):bit1,0:00,3ֽ;01,4ֽ;02,5ֽ;
#define SETUP_RETR      0x04  //Զط;bit3:0,Զط;bit7:4,Զطʱ 250*x+86us
#define RF_CH           0x05  //RFͨ,bit6:0,ͨƵ;2400+RF_CHMHZ
#define RF_SETUP        0x06  //RFĴ;bit3:(0:1Mbps,1:2Mbps);bit2:1,书;bit0:Ŵ
#define STATUS          0x07  //״̬Ĵ;bit0:TX FIFO־;bit3:1,ͨ(:6);bit4,ﵽط
                              //bit5:ݷж;bit6:ж;
#define MAX_TX  		0x10  //ﵽʹж
#define TX_OK   		0x20  //TXж
#define RX_OK   		0x40  //յж

#define OBSERVE_TX      0x08  //ͼĴ,bit7:4,ݰʧ;bit3:0,ط
#define CD              0x09  //زĴ,bit0,ز;
#define RX_ADDR_P0      0x0A  //ͨ0յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P1      0x0B  //ͨ1յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P2      0x0C  //ͨ2յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P3      0x0D  //ͨ3յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P4      0x0E  //ͨ4յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P5      0x0F  //ͨ5յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define TX_ADDR         0x10  //͵ַ(ֽǰ),ShockBurstTMģʽ,RX_ADDR_P0˵ַ
#define RX_PW_P0        0x11  //ͨ0Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P1        0x12  //ͨ1Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P2        0x13  //ͨ2Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P3        0x14  //ͨ3Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P4        0x15  //ͨ4Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P5        0x16  //ͨ5Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_FIFO_STATUS 0x17  //FIFO״̬Ĵ;bit0,RX FIFOĴձ־;bit1,RX FIFO־;bit2,3,
                              //bit4,TX FIFOձ־;bit5,TX FIFO־;bit6,1,ѭһݰ.0,ѭ;
#define FEATURE         0x1D    
#define DYNDP           0x1C

#define MASK_CONFIG_RX_IRQ 0x40
#define CONFIG_RX_IRQ_PIN 0x40

#define MASK_CONFIG_TX_IRQ 0x20
#define CONFIG_TX_IRQ_PIN 0x20

#define MASK_CONFIG_MAX_IRQ 0x10
#define CONFIG_MAX_IRQ_PIN 0x10

#define MASK_CONFIG_EN_CRC 0x08
#define CONFIG_EN_CRC 0x08
#define CONFIG_DISEN_CRC 0x00

#define MASK_CONFIG_CRC_BYTES 0x04
#define CONFIG_CRC_BYTES_2BYTE 0x04
#define CONFIG_CRC_BYTES_1BYTE 0x00

#define MASK_CONFIG_PWR_UP 0x02
#define CONFIG_PWR_UP_ON 0x02
#define CONFIG_PWR_UP_OFF 0x00

#define MASK_CONFIG_RF_MODE 0x01
#define CONFIG_RF_MODE_RX 0x01
#define CONFIG_RF_MODE_TX 0x00
typedef enum
{
    RF_PRIM_RX = 1,
    RF_PRIM_TX = 0,
}rf_mode_te;
#define MASK_SETUP_RETR_DELAY 0xf0
#define MASK_SETUP_RETR_COUNT 0x0f

#define MASK_RF_CH 0x7f

#define MASK_RF_SETUP_CONT_WAVE 0x80
#define MASK_RF_SETUP_RF_DR_LOW 0x20
#define MASK_RF_SETUP_RF_DR_HIGH 0x08
#define RF_SETUP_RF_DR_1Mbps 0x00
#define RF_SETUP_RF_DR_2Mbps 0x08
#define RF_SETUP_RF_DR_250Mbps 0x28

#define MASK_RF_SETUP_RF_PWR 0x03
#define RF_PWR_18N 0x00
#define RF_PWR_12N 0x01
#define RF_PWR_6N 0x02
#define RF_PWR_0 0x03

#define MASK_FEATURE 0x03
#define FEATURE_EN_DPL 0x04
#define FEATURE_EN_ACK_PAY 0x02
#define FEATURE_EN_DYN_ACK 0x01

//24L01ͽݿȶ
#define TX_ADR_WIDTH    5   	//5ֽڵĵַ
#define RX_ADR_WIDTH    5   	//5ֽڵĵַ
#define TX_PLOAD_WIDTH  32  	//32ֽڵûݿ
#define RX_PLOAD_WIDTH  32  	//32ֽڵûݿ

typedef void (*rf_callBack)(uint8_t *buf, uint16_t count);
typedef union 
{
    uint8_t value;
    struct 
    {
        /**
         * bit0
         * ...
         * bit7
        */
        // uint8_t obsolete : 1;   //Dont care
        uint8_t rf_pwr : 3;     //R/W Set RF output power in TX mode
                                // '00' C -18dBm
                                // '01' C -12dBm
                                // '10' C -6dBm
                                // '11' C 0dBm
                                // 111: 7dBm 110: 4dBm 
                                // 101: 3dBm 100: 1dBm 
                                // 011: 0dBm 010:-4dBm 
                                // 001:-6dBm 000:-12dBm
        uint8_t rf_dr_high : 1;    //Select between the high speed data rates. This bit
                                    // is dont care if RF_DR_LOW is set.
                                    // Encoding:
                                    // [RF_DR_LOW, RF_DR_HIGH]:
                                    // 00 C 1Mbps
                                    // 01 C 2Mbps
                                    // 10 C 250kbps
                                    // 11 C Reserved
        uint8_t pll_lock : 1;       //Force PLL lock signal. Only used in test
        uint8_t rf_dr_low : 1;      //R/W Set RF Data Rate to 250kbps. See RF_DR_HIGH
                                    // for encoding.
        uint8_t reserved : 1;       //R/W Only '0' allowed
        uint8_t cont_wave : 1;      //R/W Enables continuous carrier transmit when high
    }bits;
}rf_setup_tu;
typedef union 
{
    uint8_t value;
    struct 
    {
        /**
         * bit0
         * ...
         * bit7
        */
        rf_mode_te prim_rx : 1;     //RX/TX control
                                    // 1: PRX, 0: PTX
        uint8_t pwr_up : 1;     //1: POWER UP, 0:POWER DOWN
        uint8_t crco : 1;       //CRC encoding scheme
                                // '0' - 1 byte
                                // '1' C 2 bytes
        uint8_t enCrc : 1;      //Enable CRC. Forced high if one of the bits in the
                                // EN_AA is high
        uint8_t mask_max_rt : 1;    //Mask interrupt caused by MAX_RT
                                    // 1: Interrupt not reflected on the IRQ pin
                                    // 0: Reflect MAX_RT as active low interrupt on the
                                    // IRQ pin
        uint8_t mask_tx_ds : 1;     //Mask interrupt caused by TX_DS
                                    // 1: Interrupt not reflected on the IRQ pin
                                    // 0: Reflect TX_DS as active low interrupt on the IRQ
                                    // pin
        uint8_t mask_rx_dr : 1;     // Mask interrupt caused by RX_DR
                                    // 1: Interrupt not reflected on the IRQ pin
                                    // 0: Reflect RX_DR as active low interrupt on the
                                    // IRQ pin
        uint8_t reserved : 1;       //R/W Only '0' allowed
    }bits;
}config_tu;
typedef union 
{
    uint8_t value;
    struct 
    {
        /**
         * bit0
         * ...
         * bit7
        */
        uint8_t tx_full : 1;    //R TX FIFO full flag.
                                // 1: TX FIFO full.
                                // 0: Available locations in TX FIFO
        uint8_t rx_p_no : 3;     //R Data pipe number for the payload available for
                                // reading from RX_FIFO
                                // 000-101: Data Pipe Number
                                // 110: Not Used
                                // 111: RX FIFO Empty
        uint8_t max_rt : 1;     //R/W Maximum number of TX retransmits interrupt
                                // Write 1 to clear bit. If MAX_RT is asserted it must
                                // be cleared to enable further communication
        uint8_t tx_ds : 1;      // Data Sent TX FIFO interrupt. Asserted when
                                // packet transmitted on TX. If AUTO_ACK is activated, 
                                // this bit is set high only when ACK is
                                // received.
                                // Write 1 to clear bit.
        uint8_t rx_dr : 1;    //Data Ready RX FIFO interrupt. Asserted when
                            // new data arrives RX FIFOc.
                            // Write 1 to clear bit
        uint8_t reserved : 1;    //R/W Only '0' allowed
    }statusUint;
}status_tu;
typedef union 
{
    uint8_t setupRetrValue;
    struct 
    {
        /**
         * bit0
         * ...
         * bit7
        */
        uint8_t arc : 4;    //R/W Auto Retransmit Count
                            // 0000 CRe-Transmit disabled
                            // 0001 C Up to 1 Re-Transmit on fail of AA
                            // 
                            // 1111 C Up to 15 Re-Transmit on fail of AA
        uint8_t ard : 4;    //Auto Retransmit Delay
                            // 0000 C Wait 250?S
                            // 0001 C Wait 500?S
                            // 0010 C Wait 750?S
                            // ..
                            // 1111 C Wait 4000?S
                            // (Delay defined from end of transmission to start of
                            // next transmission)b
    }bits;
}setupRetr_tu;
typedef union 
{
    uint8_t futureValue;
    struct 
    {
        /**
         * bit0
         * ...
         * bit7
        */
        uint8_t en_dyn_ack : 1;    //R/W Enables the W_TX_PAYLOAD_NOACK command
        uint8_t en_ack_pay : 1;    //R/W Enables Payload with ACK
        uint8_t en_dpl : 1;    //R/W Enables Dynamic Payload Length
        uint8_t receved : 5;    //R/W Only 00000 allowed
    }bits;
}future_tu;

typedef struct 
{
    uint8_t isValid;
    uint8_t len;
    uint8_t package[RX_PLOAD_WIDTH];
}rfPackage_ts;
      
int NRF24L01_Init(void);

uint8_t NRF24L01_Check(void);
void NRF24L01_TxPacket(uint8_t *txbuf, uint16_t len);
void NRF24L01_getRxPacket(uint8_t *rxbuf, uint16_t len);
void NRF24L01_WriteStrobe(uint8_t strobe);

void NRF24L01_setChannl(uint8_t ch);
void NRF24L01_setRfPower(uint8_t power);
void NRF24L01_setRfBaudrate(uint32_t br);

void NRF24L01_RfMode(uint8_t mode);
void NRF24L01_carrierWave(void);
void NRF24L01_powerDown(void);
status_tu NRF24L01_readStatus(void);
int8_t NRF24L01_getRssi(void);
#endif











